import { Directive, Inject, ViewContainerRef, TemplateRef } from '@angular/core';
import { IS_PRERENDER } from './is-prerender.service';
export var ShellNoRender = (function () {
    function ShellNoRender(_viewContainer, _templateRef, _isPrerender) {
        this._viewContainer = _viewContainer;
        this._templateRef = _templateRef;
        this._isPrerender = _isPrerender;
    }
    ShellNoRender.prototype.ngOnInit = function () {
        if (this._isPrerender) {
            this._viewContainer.clear();
        }
        else {
            this._viewContainer.createEmbeddedView(this._templateRef);
        }
    };
    ShellNoRender.decorators = [
        { type: Directive, args: [{ selector: '[shellNoRender]' },] },
    ];
    /** @nocollapse */
    ShellNoRender.ctorParameters = [
        { type: ViewContainerRef, },
        { type: TemplateRef, },
        { type: undefined, decorators: [{ type: Inject, args: [IS_PRERENDER,] },] },
    ];
    return ShellNoRender;
}());
//# sourceMappingURL=shell-no-render.directive.js.map